Subject: RE: [BUG] git-2.30.0-rc1 - Transitive OpenLDAP requirement in libcurl

From: "Randall S. Becker" <[email-masked]>
Date: Mon, 21 Dec 2020 14:23:39 -0500

On December 21, 2020 1:37 PM, Junio C Hamano wrote:
> "Randall S. Becker" <[email-masked]> writes:
> 
> > The NonStop platform does not have an implementation of OpenLDAP, but
> > git is attempting to use it. We are getting unresolved references from
> > libcurl, which makes references to openldap regardless of whether it
> > exists. We do not expect git to use ldap_setup_connection, for
> > example. We need a way of disabling the use of this package. This
> > appears to be is a net new for issue for 2.23.0, which we just did not
get far
> enough on rc0 to encounter.
> 
> I assume "23" on the last line is typo for "30".

Yes, I goofed up here. 2.30.

> Between v2.29.0..v2.30.0-rc1, there is nothing other than 3b990aa6
> (push: parse and set flag for "--force-if-includes", 2020-10-03), which
seem
> to have nothing to do with auth, that touches http*.c or remote-curl.c
> 
> Is it possible that you updated your build procedure and/or options for
libcurl
> since last time you built a working Git successfully?

The only change on the system anywhere near the toolchain was removing
MKDIR_WO_TRAILING_SLASH and  NO_SETITIMER.

> If you build v2.29.0 with the same toolchain and library that failed with
-rc1,
> does the result work OK?
> 
> Does NonStop software collection have programs other than Git that links
> with libcurl, and if so do they work (in other words, is the latest source
of Git
> the only thing that suffers from this issue)?

git is the only product my group builds that uses libcurl. There is a less
functional
version of libcurl that comes with the operating system that we ignore. We
are not
linking with that version. The version of curl we have, we built but not
since 2.29.2.
So  I'm confused.

> 
> Sorry, I have *no* further suggestions even if you answered any of the
above
> questions to me, but I hope others (inclusing you and your
> folks) may have better insights after answering the above questions
> ;-)
> 
> > Need assistance to resolve this.
> >
> > Thanks,
> > Randall
> >
> > Sample (there are more) references:
> >
> > eld command line:
> >    /usr/bin/eld -o git-imap-send -set systype oss -set highpin on -set
> >    highrequestor on -set inspect on /usr/lib/ccplmain.o imap-send.o
http.o
> >    common-main.o -L/usr/local/lib -lcurl -lssl -lcrypto -lssl -lcrypto
-lz
> >    -lssl -lcrypto -lcrypto libgit.a xdiff/lib.a -lz -lintl -liconv
> >    -L/usr/local/lib -lfloss -lutil -lrld -L /G/system/sys04 -lcre -lcrtl
> >    -lossk -lossf -lsec -li18n -licnv -losse -linet -lossh -lossc
> >    -allow_duplicate_procs
> >
> > **** ERROR **** [1210]:
> >    /usr/local/lib/libcurl.a(libcurl_la-openldap.o): In function
> >    `ldap_setup_connection':
> >    libcurl_la-openldap.o(.text._153926392+0x72): unresolved reference to
> >    ldap_url_parse.
> >
> >
> > -- Brief whoami:
> >  NonStop developer since approximately 211288444200000000  UNIX
> > developer since approximately 421664400
> > -- In my real life, I talk too much.